/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ZoomablePanel.java
 *
 * Created on 25 avr. 2010, 16:57:53
 */

package panda;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.AffineTransform;
import javax.swing.JPanel;
import javax.swing.JViewport;

/**
 *
 * @author Ancmin
 */
public class ZoomablePanel extends javax.swing.JPanel {

    private Point curseurSouris = null;
    
    private double zoom = 1.0;

    public double getZoom() {
        return zoom;
    }


    public void setZoom(double zoom)
    {
        this.zoom = zoom;
    }



    public double getXLogical(double physicalX)
    {
        return physicalX / zoom;
    }

    public double getYLogical(double physicalY)
    {
        return physicalY / zoom;
    }

    public double getXPhysical(double logicalX)
    {
        return logicalX * zoom;
    }

    public double getYPhysical(double logicalY)
    {
        return logicalY * zoom;
    }

    public Rectangle getRectangleLogical(Rectangle rectanglePhysical)
    {
        return new Rectangle((int) getXLogical(rectanglePhysical.x),
                             (int) getYLogical(rectanglePhysical.y),
                             (int) getXLogical(rectanglePhysical.width),
                             (int) getYLogical(rectanglePhysical.height));
    }

    public Font getFontPhysical(Font font)
    {
        return new Font(font.getName(), font.getStyle(), (int) (font.getSize() * zoom));
    }

    public Rectangle getRectanglePhysical(Rectangle rectangleLogical)
    {
        return new Rectangle((int) getXPhysical(rectangleLogical.x),
                             (int) getYPhysical(rectangleLogical.y),
                             (int) getXPhysical(rectangleLogical.width),
                             (int) getYPhysical(rectangleLogical.height));
    }

    public Dimension getDimensionPhysical(Dimension dimensionLogical)
    {
        return new Dimension((int) (dimensionLogical.width * zoom),
                             (int) (dimensionLogical.height * zoom));
    }

    public Point getPointLogical(Point pointPhysical)
    {
        return new Point((int) getXLogical(pointPhysical.x), (int) getYLogical(pointPhysical.y));
    }

    public Point getPointPhysical(Point pointLogical)
    {
        return new Point((int) getXPhysical(pointLogical.x), (int) getYPhysical(pointLogical.y));
    }



    private java.awt.event.MouseEvent mouseEventAdapt(java.awt.event.MouseEvent evt)
    {
       return new java.awt.event.MouseEvent(
                             (Component) evt.getSource(),
                             evt.getID(),
                             evt.getWhen(),
                             evt.getModifiers(),
                             (int) (evt.getX() / zoom),
                             (int) (evt.getY() / zoom),
                             evt.getClickCount(),
                             evt.isPopupTrigger());
    }






    protected void zoomMouseListenerAdapt()
    {
        for(final MouseListener m : getMouseListeners())
        {
            removeMouseListener(m);
            addMouseListener(new java.awt.event.MouseAdapter() {
                @Override
                public void mouseClicked(java.awt.event.MouseEvent evt) {
                    m.mouseClicked(mouseEventAdapt(evt));
                    //m.mouseClicked(evt);
                }
                @Override
                public void mousePressed(java.awt.event.MouseEvent evt) {
                     m.mousePressed(mouseEventAdapt(evt));
                     curseurSouris = evt.getPoint();
                     //timer.start();
                }
                @Override
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                m.mouseReleased(mouseEventAdapt(evt));
            }
            });
        }


        for(final MouseMotionListener m : getMouseMotionListeners())
        {
            removeMouseMotionListener(m);
            addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
                @Override
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                m.mouseDragged(mouseEventAdapt(evt));
            }
                @Override
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                m.mouseMoved(mouseEventAdapt(evt));
            }
        });
        }
            

    }

    /** Creates new form ZoomablePanel */
    public ZoomablePanel() {
        initComponents();

        
        }
        

    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setName("Form"); // NOI18N
        addMouseWheelListener(new java.awt.event.MouseWheelListener() {
            public void mouseWheelMoved(java.awt.event.MouseWheelEvent evt) {
                formMouseWheelMoved(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void formMouseWheelMoved(java.awt.event.MouseWheelEvent evt) {//GEN-FIRST:event_formMouseWheelMoved
        if(evt.isControlDown())
        {
            double newZoom = getZoom() - ((double) evt.getWheelRotation())/10.0;
            if((newZoom < 0.4) || (newZoom > 2.0))
                 return;


            Point pointPhysical = evt.getPoint();
            Point pointLogical = getPointLogical(pointPhysical);

            int vx = ((JViewport) getParent()).getViewPosition().x;
            int vy = ((JViewport) getParent()).getViewPosition().y;

            setZoom(newZoom);

            Point newPointPhysical = getPointPhysical(pointLogical);
            ((JViewport) getParent()).setViewPosition(new Point(vx + newPointPhysical.x - pointPhysical.x,
                       vy +  newPointPhysical.y - pointPhysical.y));


            
            getParent().doLayout();
            getParent().repaint();
            repaint();
        }
        else
        {
            int y = ((JViewport) getParent()).getViewPosition().y + evt.getWheelRotation() * 32;

            if(y < 0)
                return;

            ((JViewport) getParent()).setViewPosition(new Point(((JViewport) getParent()).getViewPosition().x,
                       y));


            //setLocation(getLocation().x, getLocation().y - evt.getWheelRotation() * 32);
        }
    }//GEN-LAST:event_formMouseWheelMoved



    AffineTransform savedTransform;
    AffineTransform initialTransform;

    /**
     * should not been called from outside
     * (but it is called because copyArea is not implemented...)
     */
    public void transformationWithZoom(Graphics g)
    {
        //((Graphics2D) g).scale(zoom, zoom);
        ((Graphics2D) g).setTransform(savedTransform);
    }

    /**
     * should not been called from outside
     * (but it is called because copyArea is not implemented...)
     */
    public void transformationNoZoom(Graphics g)
    {
         savedTransform = ((Graphics2D) g).getTransform();
        ((Graphics2D) g).setTransform(initialTransform);
    }


    
    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.clearRect(0, 0, getWidth(), getHeight());
        initialTransform = ((Graphics2D) g).getTransform();
        ((Graphics2D) g).scale(zoom, zoom);
       // super.paintComponent(g);

        

        
    }





    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
